account/urls.py
from django.conf.urls import url

from account.views import login_view, logout_view, register_view, home

urlpatterns = [
    url(r'^register/?$', register_view, name='register'),
    url(r'^login/?$', login_view, name='login'),
    url(r'^logout/?$', logout_view, name='logout'),
    url(r'^home/?$', home, name='home'),
]

base/urls.py
from django.conf.urls import url

from base.views import homepage

urlpatterns = [
    url(r'^$', homepage, name='home'),
]

finem_imperii/urls.py
from django.conf.urls import url, include
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('base.urls', namespace='base'), name='base'),
    url(r'^', include('account.urls', namespace='account'), name='account'),
    url(r'^', include('world.urls', namespace='world'), name='world'),
    url(r'^character/', include('character.urls', namespace='character'), name='character'),
    url(r'^unit/', include('unit.urls', namespace='unit'), name='unit'),
    url(r'^messaging/', include('messaging.urls', namespace='messaging'), name='messaging'),
    url(r'^organization/', include('organization.urls', namespace='organization'), name='organization'),
    url(r'^battle/', include('battle.urls', namespace='battle'), name='battle'),
    url(r'^help/', include('help.urls', namespace='help'), name='help'),
]

help/urls.py
from django.conf.urls import url
from django.views.generic.base import TemplateView

urlpatterns = [
    url(r'^$', TemplateView.as_view(template_name='help/home.html'), name='home'),
    url(r'^fundamental$', TemplateView.as_view(template_name='help/fundamental.html'), name='fundamental'),
    url(r'^design', TemplateView.as_view(template_name='help/design.html'), name='design'),
    url(r'^mechanics', TemplateView.as_view(template_name='help/mechanics.html'), name='mechanics'),
    url(r'^about$', TemplateView.as_view(template_name='help/about.html'), name='about'),
]

unit/urls.py
from django.conf.urls import url

from decorators import inchar_required
from unit.views.actions import disband, conquest_action, rename, pay_debt
from unit.views.recruitment import RecruitmentView
from unit.views.settings import battle_settings, status_change
from unit.views.unit import unit_view

urlpatterns = [
    url(r'^recruit$', inchar_required(RecruitmentView.as_view()), name='recruit'),
    url(r'^(?P<unit_id>[0-9]+)$', unit_view, name='unit'),
    url(r'^(?P<unit_id>[0-9]+)/rename$', rename, name='rename'),
    url(r'^(?P<unit_id>[0-9]+)/battle_settings', battle_settings, name='battle_settings'),
    url(r'^(?P<unit_id>[0-9]+)/pay', pay_debt, name='pay_debt'),
    url(r'^(?P<unit_id>[0-9]+)/disband', disband, name='disband'),
    url(r'^(?P<unit_id>[0-9]+)/conquest', conquest_action, name='conquest_action'),
    url(r'^(?P<unit_id>[0-9]+)/(?P<new_status>[ a-z]+)', status_change, name='status_change'),
]

world/urls.py
from django.conf.urls import url

from world.views import world_view, \
    minimap_view, world_view_iframe, tile_view, \
    tile_view_iframe

urlpatterns = [
    url(r'^tile/(?P<tile_id>[0-9]+)$', tile_view, name='tile'),
    url(r'^tile_iframe/(?P<tile_id>[0-9]+)$', tile_view_iframe, name='tile_iframe'),
    url(r'^world/(?P<world_id>[0-9]+)$', world_view, name='world'),
    url(r'^world_iframe/(?P<world_id>[0-9]+)$', world_view_iframe, name='world_iframe'),
    url(r'^minimap$', minimap_view, name='minimap'),
]

base/models.py
from django.db import models

# Create your models here.

base/views.py
from django.shortcuts import render, redirect

from messaging.models import ServerMOTD


def homepage(request):
    if request.user.is_authenticated():
        return redirect('account:home')
    else:
        context = {
            'server_messages': ServerMOTD.objects.all() if request.user.is_staff
                               else ServerMOTD.objects.filter(draft=False),
        }
        return render(request, "base/homepage.html", context=context)

base/templates/base/base.html
{% extends 'base/base_naked.html' %}

{% load cookielaw_tags %}
{% load staticfiles %}

{% block body %}

    <!-- Gitter -->
    <script src="https://sidecar.gitter.im/dist/sidecar.v1.js" async
            defer></script>
    <script>
        ((window.gitter = {}).chat = {}).options = {
            room: 'finemimperii/Lobby',
            activationElement: false
        };
    </script>

    <!-- cookie law -->
    <script src="{% static 'cookielaw/js/cookielaw.js' %}?{{ git_rev }}"></script>

    {% include "base/topnav.html" %}

    <div class="container-fluid">
        {% cookielaw_banner %}

        {% if request.hero and not hide_sidebar %}
            <div class="col-xs-12 col-md-3 well">
                <p class="text-center">
                    It's {{ request.hero.world.get_current_date }} in
                    <a href="{{ request.hero.world.get_absolute_url }}">{{ request.hero.world }}</a>.
                </p>
                <p class="text-center">
                    You are in {{ request.hero.location }}, a {{ request.hero.location.size_name }} in
                    {{ request.hero.location.tile.get_html_link|safe }}.
                </p>
                <iframe
                        id="minimap"
                        class="placeholder minimap"
                        scrolling="no"
                        src="{% url 'world:minimap' %}"
                ></iframe>

                <p class="text-center">
                    {{ request.hero.location.tile.get_html_link|safe }}
                    is controlled by
                    {{ request.hero.location.tile.controlled_by.get_violence_monopoly.get_html_link|safe }}.
                </p>

                {% for battle in request.hero.location.tile.get_current_battles %}
                    <p class="text-center">
                        <a href="{{ battle.get_absolute_url }}" class="btn btn-danger">
                            Battle in progress
                        </a>
                    </p>
                {% endfor %}

                <hr>

                <h5>Your position</h5>
                <ul>
                    {% for organization in request.hero.organization_set.all %}
                        <li>
                            {% if not organization.is_position %}Member of{% endif %}
                            {{ organization.get_html_link|safe }}
                        </li>
                    {% endfor %}
                </ul>

                <table class="table table-striped table-hover">
                    <thead>
                        <tr><td class="h5">Your units</td></tr>
                    </thead>
                    <tbody>
                        {% for unit in request.hero.worldunit_set.all %}
                            <tr>
                                <td>
                                    {{ unit.get_html_link|safe }}
                                    {% if unit.get_current_battle %}
                                        <a
                                                href="{{ unit.get_current_battle.get_absolute_url }}"
                                                class="btn btn-danger btn-sm"
                                        >Battle</a>
                                    {% endif %}
                                </td>
                                <td>
                                    {{ unit.status|capfirst }}
                                </td>
                            </tr>
                        {% empty %}
                            <tr><td class="text-center">
                                You own no units.<br>
                                <a href="{% url 'unit:recruit' %}"
                                   class="btn {% if request.hero.has_conscripting_capability_in_current_location %}btn-primary{% else %}btn-default{% endif %} btn-sm">
                                    Recruit
                                </a>
                            </td></tr>
                        {% endfor %}
                    </tbody>
                </table>

                <span class="pull-right">
                    <a href="{% url 'character:inventory' %}" class="btn btn-sm btn-primary">
                        Manage
                    </a>
                </span>
                <h5>Your inventory</h5>

                <ul>
                    <li>{{ request.hero.cash }} silver coins</li>
                    {% for item in request.hero.inventoryitem_set.all %}
                        <li>{{ item }}</li>
                    {% endfor %}
                </ul>
            </div>
            <div class="col-xs-12 col-md-9">
        {% endif %}

        {% include 'base/messages.html' %}

        {% block content %}{% endblock %}

        {% if request.hero and not hide_sidebar %}
            </div>
        {% endif %}
    </div>

    <footer class="footer">
        <div class="container">
            <p class="text-muted">
                <a href="{% url 'help:about' %}">Finem Imperii</a> - {% include 'base/build.html' %}
            </p>
        </div>
    </footer>
{% endblock %}

base/templates/base/base_naked.html
{% load staticfiles %}
<!DOCTYPE html>

<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
        <title>Finem Imperii</title>

        <!-- Bootstrap -->
        <link rel="stylesheet" type="text/css" href="{% static 'base/3rd/css/bootstrap.min.css' %}?{{ git_rev }}" />
        <link rel="stylesheet" type="text/css" href="{% static 'base/3rd/css/bootstrap.theme.min.css' %}?{{ git_rev }}" />

        <!-- custom stylings -->
        <link rel="stylesheet" type="text/css" href="{% static 'base/3rd/css/sticky-footer.css' %}?{{ git_rev }}" />
        <link rel="stylesheet" type="text/css" href="{% static 'base/css/backend_developer.css' %}?{{ git_rev }}" />
        <link rel="stylesheet" type="text/css" href="{% static 'base/css/icons.css' %}?{{ git_rev }}" />

        <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
        <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
            <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
        <![endif]-->

        <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
        <script src="{% static 'base/3rd/js/jquery.min.js' %}?{{ git_rev }}"></script>
        <!-- Include all compiled plugins (below), or include individual files as needed -->

        <!-- Latest compiled and minified JavaScript -->
        <script src="{% static 'base/3rd/js/bootstrap.min.js' %}?{{ git_rev }}"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
                crossorigin="anonymous"></script>

        <!-- Chart.js -->
        <script src="{% static 'base/3rd/js/Chart.bundle.min.js' %}?{{ git_rev }}"
                crossorigin="anonymous"></script>

        <!-- Google Analytics -->
        <script>
              (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
              (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
              m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
              })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

              ga('create', 'UA-100151510-1', 'auto');
              ga('send', 'pageview');
        </script>

    </head>
    <body class="body">
        {% block body %}{% endblock %}
    </body>
</html>

base/templates/base/build.html
<span class="label label-info">dev</span>

base/templates/base/homepage.html
{% extends "base/base.html" %}

{% block content %}

    <div class="col-xs-12 col-md-8 jumbotron">
        <h1 class="page-header">The Empire has fallen</h1>
        <p>
            After seven prosper centuries of peace under the rule of the Empire, it entered a stage of spiralling
            decadence. Not even the noblest rulers, the brightest bureaucrats or bravest generals were able to stop it.
            They were too few of them amongst the corrupt, the lazy and the feckless. What seemed impossible in the
            past, what was for many even unthinkable, happened in just a few decades: the Empire <i>fell</i>.
        </p>
        <p>
            It has now been over a hundred years of bloody civil wars, anarchy, shameless corruption and violence that
            has profoundly decimated the population. Trust in leaders became trait to be exploited. The future looked
            grim. But now new realms and rulers are starting to rise again, bringing the people the hope of seeing order
            and peace restored.
        </p>
        <p>
            Who will be able to bring hope and dignity to the world? Will you help bringing back the golden days
            of the Empire?
        </p>

        <h2>Introduction</h2>
        <p>
            Finem Imperii is a web-based role-strategy multiplayer game. Characters are part of a long-lived open
            persistent world placed in the late middle ages, where they will usually take the role of prominent members
            of society (e.g. commanders, traders, treasurers, rulers). Cooperation among players is a core part of the
            game, and is required for most scenarios.
        </p>
        <p>
            Unlike other games, the players do not need to log-in frequently or at certain times. Also, the level of
            deepness and involvement can be variable, and there is no benefit from spending large amounts of time
            playing. There is no fixed objective in this game, but there are many open possibilities for the players.
        </p>
        <p>
            You can <a href="{% url 'account:register' %}">create an account</a> for free if you don't have one yet.
            Else, <a href="{% url 'account:login' %}">log-in</a> and continue playing.
        </p>
        <p>
            Fiinem Imperii is free software. Feel free to
            <a href="https://github.com/jardiacaj/finem_imperii">contribute</a>.
        </p>
    </div>
    <div class="col-xs-12 col-md-4">
        <h3>News</h3>
        {% for message in server_messages %}
            <h4>{{ message.title }}</h4>
            {{ message.html_content|safe }}
        {% endfor %}
    </div>
{% endblock %}

base/templates/base/messages.html
{% if messages %}
        {% for message in messages %}
            <div class="alert alert-{{ message.tags }} alert-dismissible" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                {{ message }}
            </div>
        {% endfor %}
{% endif %}

base/templates/base/topnav.html
{% load staticfiles %}
{% load extra_filters %}

<nav class="navbar navbar-inverse">
    <div class="container-fluid">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse"
                    data-target="#bs-example-navbar-collapse-2">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="{% url 'base:home' %}">Finem Imperii</a>
        </div>

        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-2">
            <ul class="nav navbar-nav">

                {% if user.is_authenticated %}

                    {% if request.hero %}
                        <li class="active">
                            <a href="{{ request.hero.activation_url }}" class="active">
                                {{ request.hero.get_html_name|safe }}
                            </a>
                        </li>
                    {% endif %}

                    <li class="dropdown">
                        <a href="{% url 'account:home' %}" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
                            {% if request.hero %}Switch{% else %}Choose character{% endif %}
                            <span class="caret"></span>
                        </a>

                        <ul class="dropdown-menu" role="menu">
                            {% for character in user.character_set.all %}
                                {% if not character.paused %}
                                    <li><a href="{{ character.activation_url }}">
                                        {{ character.get_html_name|safe }}
                                    </a></li>
                                {% endif %}
                            {% endfor %}
                        </ul>

                    </li>

                    {% if request.hero %}
                        <li><p class="navbar-text">
                            {{ request.hero.hours_in_turn_left }}
                            hours left
                        </p></li>

                        <li class="{% if request.hero.unread_messages.exists %}active{% endif %}">
                            <a href="{% url 'messaging:home' %}" class="{% if request.hero.unread_messages.exists %}active{% endif %}">
                                Messages
                                {% if request.hero.unread_messages.exists %}
                                    <span class="badge">
                                        <span class="glyphicon glyphicon-envelope" aria-hidden="true"></span>
                                        {{ request.hero.unread_messages.count }}
                                    </span>
                                {% endif %}
                            </a>
                        </li>

                        <li>
                            <a href="{% url 'messaging:compose' %}">
                            <span class="glyphicon glyphicon-pencil" aria-hidden="true"></span>
                            </a>
                        </li>

                    {% endif %}

                {%  else %}

                    <li><a href="{% url 'account:register' %}">Join</a></li>
                    <li><a href="{% url 'help:about' %}">About</a></li>

                {% endif %}

            </ul>
            <ul class="nav navbar-nav navbar-right">
                {% if user.is_staff %}
                    <li class="dropdown">
                        <a href="/admin" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
                            Admin
                            <span class="caret"></span>
                        </a>
                        <ul class="dropdown-menu" role="menu">
                            <li><a href="/admin">Django admin</a></li>
                        </ul>
                    </li>
                {% endif %}
                <li>
                    <a href="#" class="js-gitter-toggle-chat-button">Chat</a>
                </li>
                <li><a href="{% url 'help:home' %}">Game Manual</a></li>
                {% if user.is_authenticated %}
                    <li><a href="{% url 'account:logout' %}">Logout ({{ user }})</a></li>
                {%  else %}
                    <li><a href="{% url 'account:login' %}">Login</a></li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>